/*
 *  vbfamprojectmanager.vala - Vala Build Framework library
 *  
 *  Copyright (C) 2008 - Andrea Del Signore <sejerpz@tin.it>
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 */

#ifndef __AM_VBFAMPROJECTMANAGER_H__
#define __AM_VBFAMPROJECTMANAGER_H__

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <vbfiprojectmanager.h>
#include <vbfproject.h>

G_BEGIN_DECLS


#define VBF_AM_TYPE_PROJECT_MANAGER (vbf_am_project_manager_get_type ())
#define VBF_AM_PROJECT_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VBF_AM_TYPE_PROJECT_MANAGER, VbfAmProjectManager))
#define VBF_AM_PROJECT_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VBF_AM_TYPE_PROJECT_MANAGER, VbfAmProjectManagerClass))
#define VBF_AM_IS_PROJECT_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VBF_AM_TYPE_PROJECT_MANAGER))
#define VBF_AM_IS_PROJECT_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VBF_AM_TYPE_PROJECT_MANAGER))
#define VBF_AM_PROJECT_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VBF_AM_TYPE_PROJECT_MANAGER, VbfAmProjectManagerClass))

typedef struct _VbfAmProjectManager VbfAmProjectManager;
typedef struct _VbfAmProjectManagerClass VbfAmProjectManagerClass;
typedef struct _VbfAmProjectManagerPrivate VbfAmProjectManagerPrivate;

struct _VbfAmProjectManager {
	GObject parent_instance;
	VbfAmProjectManagerPrivate * priv;
};

struct _VbfAmProjectManagerClass {
	GObjectClass parent_class;
};


VbfAmProjectManager* vbf_am_project_manager_construct (GType object_type);
VbfAmProjectManager* vbf_am_project_manager_new (void);
GType vbf_am_project_manager_get_type (void);


G_END_DECLS

#endif
