/*
 *  vbfconfignode.vala - Vala Build Framework library
 *  
 *  Copyright (C) 2008 - Andrea Del Signore <sejerpz@tin.it>
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 */

#include <vbfconfignode.h>




enum  {
	VBF_CONFIG_NODE_DUMMY_PROPERTY
};
static char* vbf_config_node_real_to_string (VbfConfigNode* self);
static gpointer vbf_config_node_parent_class = NULL;
static void vbf_config_node_finalize (GObject* obj);



static char* vbf_config_node_real_to_string (VbfConfigNode* self) {
	g_return_val_if_fail (self != NULL, NULL);
	g_critical ("Type `%s' does not implement abstract method `vbf_config_node_to_string'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


char* vbf_config_node_to_string (VbfConfigNode* self) {
	return VBF_CONFIG_NODE_GET_CLASS (self)->to_string (self);
}


static void vbf_config_node_class_init (VbfConfigNodeClass * klass) {
	vbf_config_node_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = vbf_config_node_finalize;
	VBF_CONFIG_NODE_CLASS (klass)->to_string = vbf_config_node_real_to_string;
}


static void vbf_config_node_instance_init (VbfConfigNode * self) {
	self->parent = NULL;
}


static void vbf_config_node_finalize (GObject* obj) {
	VbfConfigNode * self;
	self = VBF_CONFIG_NODE (obj);
	G_OBJECT_CLASS (vbf_config_node_parent_class)->finalize (obj);
}


GType vbf_config_node_get_type (void) {
	static GType vbf_config_node_type_id = 0;
	if (vbf_config_node_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (VbfConfigNodeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vbf_config_node_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VbfConfigNode), 0, (GInstanceInitFunc) vbf_config_node_instance_init, NULL };
		vbf_config_node_type_id = g_type_register_static (G_TYPE_OBJECT, "VbfConfigNode", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	}
	return vbf_config_node_type_id;
}




