/*
 *  vbfconfignodepair.vala - Vala Build Framework library
 *  
 *  Copyright (C) 2008 - Andrea Del Signore <sejerpz@tin.it>
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 */

#include <vbfconfignodepair.h>




enum  {
	VBF_CONFIG_NODE_PAIR_DUMMY_PROPERTY
};
static gpointer vbf_config_node_pair_parent_class = NULL;
static void vbf_config_node_pair_finalize (GObject* obj);



VbfConfigNodePair* vbf_config_node_pair_construct (GType object_type, VbfConfigNode* source, VbfConfigNode* destination) {
	VbfConfigNodePair * self;
	VbfConfigNode* _tmp1;
	VbfConfigNode* _tmp0;
	VbfConfigNode* _tmp3;
	VbfConfigNode* _tmp2;
	g_return_val_if_fail (source != NULL, NULL);
	self = g_object_newv (object_type, 0, NULL);
	_tmp1 = NULL;
	_tmp0 = NULL;
	self->source = (_tmp1 = (_tmp0 = source, (_tmp0 == NULL) ? NULL : g_object_ref (_tmp0)), (self->source == NULL) ? NULL : (self->source = (g_object_unref (self->source), NULL)), _tmp1);
	_tmp3 = NULL;
	_tmp2 = NULL;
	self->destination = (_tmp3 = (_tmp2 = destination, (_tmp2 == NULL) ? NULL : g_object_ref (_tmp2)), (self->destination == NULL) ? NULL : (self->destination = (g_object_unref (self->destination), NULL)), _tmp3);
	return self;
}


VbfConfigNodePair* vbf_config_node_pair_new (VbfConfigNode* source, VbfConfigNode* destination) {
	return vbf_config_node_pair_construct (VBF_TYPE_CONFIG_NODE_PAIR, source, destination);
}


static void vbf_config_node_pair_class_init (VbfConfigNodePairClass * klass) {
	vbf_config_node_pair_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = vbf_config_node_pair_finalize;
}


static void vbf_config_node_pair_instance_init (VbfConfigNodePair * self) {
}


static void vbf_config_node_pair_finalize (GObject* obj) {
	VbfConfigNodePair * self;
	self = VBF_CONFIG_NODE_PAIR (obj);
	(self->source == NULL) ? NULL : (self->source = (g_object_unref (self->source), NULL));
	(self->destination == NULL) ? NULL : (self->destination = (g_object_unref (self->destination), NULL));
	G_OBJECT_CLASS (vbf_config_node_pair_parent_class)->finalize (obj);
}


GType vbf_config_node_pair_get_type (void) {
	static GType vbf_config_node_pair_type_id = 0;
	if (vbf_config_node_pair_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (VbfConfigNodePairClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vbf_config_node_pair_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VbfConfigNodePair), 0, (GInstanceInitFunc) vbf_config_node_pair_instance_init, NULL };
		vbf_config_node_pair_type_id = g_type_register_static (G_TYPE_OBJECT, "VbfConfigNodePair", &g_define_type_info, 0);
	}
	return vbf_config_node_pair_type_id;
}




