/*
 *  vbfconfignodepair.vala - Vala Build Framework library
 *  
 *  Copyright (C) 2008 - Andrea Del Signore <sejerpz@tin.it>
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 */

#ifndef __VBFCONFIGNODEPAIR_H__
#define __VBFCONFIGNODEPAIR_H__

#include <glib.h>
#include <glib-object.h>
#include <vbfconfignode.h>

G_BEGIN_DECLS


#define VBF_TYPE_CONFIG_NODE_PAIR (vbf_config_node_pair_get_type ())
#define VBF_CONFIG_NODE_PAIR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VBF_TYPE_CONFIG_NODE_PAIR, VbfConfigNodePair))
#define VBF_CONFIG_NODE_PAIR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VBF_TYPE_CONFIG_NODE_PAIR, VbfConfigNodePairClass))
#define VBF_IS_CONFIG_NODE_PAIR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VBF_TYPE_CONFIG_NODE_PAIR))
#define VBF_IS_CONFIG_NODE_PAIR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VBF_TYPE_CONFIG_NODE_PAIR))
#define VBF_CONFIG_NODE_PAIR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VBF_TYPE_CONFIG_NODE_PAIR, VbfConfigNodePairClass))

typedef struct _VbfConfigNodePair VbfConfigNodePair;
typedef struct _VbfConfigNodePairClass VbfConfigNodePairClass;
typedef struct _VbfConfigNodePairPrivate VbfConfigNodePairPrivate;

struct _VbfConfigNodePair {
	GObject parent_instance;
	VbfConfigNodePairPrivate * priv;
	VbfConfigNode* source;
	VbfConfigNode* destination;
};

struct _VbfConfigNodePairClass {
	GObjectClass parent_class;
};


VbfConfigNodePair* vbf_config_node_pair_construct (GType object_type, VbfConfigNode* source, VbfConfigNode* destination);
VbfConfigNodePair* vbf_config_node_pair_new (VbfConfigNode* source, VbfConfigNode* destination);
GType vbf_config_node_pair_get_type (void);


G_END_DECLS

#endif
