/*
 *  vbfiprojectmanager.vala - Vala Build Framework library
 *  
 *  Copyright (C) 2008 - Andrea Del Signore <sejerpz@tin.it>
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 */

#include <vbfiprojectmanager.h>







gboolean vbf_iproject_manager_probe (VbfIProjectManager* self, const char* project_file) {
	return VBF_IPROJECT_MANAGER_GET_INTERFACE (self)->probe (self, project_file);
}


VbfProject* vbf_iproject_manager_open (VbfIProjectManager* self, const char* project_file) {
	return VBF_IPROJECT_MANAGER_GET_INTERFACE (self)->open (self, project_file);
}


void vbf_iproject_manager_refresh (VbfIProjectManager* self, VbfProject* project) {
	VBF_IPROJECT_MANAGER_GET_INTERFACE (self)->refresh (self, project);
}


static void vbf_iproject_manager_base_init (VbfIProjectManagerIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
	}
}


GType vbf_iproject_manager_get_type (void) {
	static GType vbf_iproject_manager_type_id = 0;
	if (vbf_iproject_manager_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (VbfIProjectManagerIface), (GBaseInitFunc) vbf_iproject_manager_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		vbf_iproject_manager_type_id = g_type_register_static (G_TYPE_INTERFACE, "VbfIProjectManager", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (vbf_iproject_manager_type_id, G_TYPE_OBJECT);
	}
	return vbf_iproject_manager_type_id;
}




