/*
 *  vbfiprojectmanager.vala - Vala Build Framework library
 *  
 *  Copyright (C) 2008 - Andrea Del Signore <sejerpz@tin.it>
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 */

#ifndef __VBFIPROJECTMANAGER_H__
#define __VBFIPROJECTMANAGER_H__

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <vbfproject.h>

G_BEGIN_DECLS


#define VBF_TYPE_IPROJECT_MANAGER (vbf_iproject_manager_get_type ())
#define VBF_IPROJECT_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VBF_TYPE_IPROJECT_MANAGER, VbfIProjectManager))
#define VBF_IS_IPROJECT_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VBF_TYPE_IPROJECT_MANAGER))
#define VBF_IPROJECT_MANAGER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), VBF_TYPE_IPROJECT_MANAGER, VbfIProjectManagerIface))


struct _VbfIProjectManagerIface {
	GTypeInterface parent_iface;
	gboolean (*probe) (VbfIProjectManager* self, const char* project_file);
	VbfProject* (*open) (VbfIProjectManager* self, const char* project_file);
	void (*refresh) (VbfIProjectManager* self, VbfProject* project);
};


gboolean vbf_iproject_manager_probe (VbfIProjectManager* self, const char* project_file);
VbfProject* vbf_iproject_manager_open (VbfIProjectManager* self, const char* project_file);
void vbf_iproject_manager_refresh (VbfIProjectManager* self, VbfProject* project);
GType vbf_iproject_manager_get_type (void);


G_END_DECLS

#endif
