/*
 *  vbfpackage.vala - Vala Build Framework library
 *  
 *  Copyright (C) 2008 - Andrea Del Signore <sejerpz@tin.it>
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 */

#include <vbfpackage.h>




enum  {
	VBF_PACKAGE_DUMMY_PROPERTY
};
static gpointer vbf_package_parent_class = NULL;
static void vbf_package_finalize (GObject* obj);



VbfPackage* vbf_package_construct (GType object_type, const char* id) {
	VbfPackage * self;
	char* _tmp1;
	const char* _tmp0;
	char* _tmp3;
	const char* _tmp2;
	g_return_val_if_fail (id != NULL, NULL);
	self = g_object_newv (object_type, 0, NULL);
	_tmp1 = NULL;
	_tmp0 = NULL;
	self->id = (_tmp1 = (_tmp0 = id, (_tmp0 == NULL) ? NULL : g_strdup (_tmp0)), self->id = (g_free (self->id), NULL), _tmp1);
	_tmp3 = NULL;
	_tmp2 = NULL;
	self->name = (_tmp3 = (_tmp2 = id, (_tmp2 == NULL) ? NULL : g_strdup (_tmp2)), self->name = (g_free (self->name), NULL), _tmp3);
	return self;
}


VbfPackage* vbf_package_new (const char* id) {
	return vbf_package_construct (VBF_TYPE_PACKAGE, id);
}


static void vbf_package_class_init (VbfPackageClass * klass) {
	vbf_package_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = vbf_package_finalize;
}


static void vbf_package_instance_init (VbfPackage * self) {
}


static void vbf_package_finalize (GObject* obj) {
	VbfPackage * self;
	self = VBF_PACKAGE (obj);
	self->id = (g_free (self->id), NULL);
	self->name = (g_free (self->name), NULL);
	self->constraint = (g_free (self->constraint), NULL);
	(self->version == NULL) ? NULL : (self->version = (g_object_unref (self->version), NULL));
	G_OBJECT_CLASS (vbf_package_parent_class)->finalize (obj);
}


GType vbf_package_get_type (void) {
	static GType vbf_package_type_id = 0;
	if (vbf_package_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (VbfPackageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vbf_package_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VbfPackage), 0, (GInstanceInitFunc) vbf_package_instance_init, NULL };
		vbf_package_type_id = g_type_register_static (G_TYPE_OBJECT, "VbfPackage", &g_define_type_info, 0);
	}
	return vbf_package_type_id;
}




