/*
 *  vbfstringliteral.vala - Vala Build Framework library
 *  
 *  Copyright (C) 2008 - Andrea Del Signore <sejerpz@tin.it>
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 */

#include <vbfstringliteral.h>




enum  {
	VBF_STRING_LITERAL_DUMMY_PROPERTY
};
static char* vbf_string_literal_real_to_string (VbfConfigNode* base);
static gpointer vbf_string_literal_parent_class = NULL;
static void vbf_string_literal_finalize (GObject* obj);
static int _vala_strcmp0 (const char * str1, const char * str2);



VbfStringLiteral* vbf_string_literal_construct (GType object_type, const char* data) {
	VbfStringLiteral * self;
	char* _tmp1;
	const char* _tmp0;
	g_return_val_if_fail (data != NULL, NULL);
	self = g_object_newv (object_type, 0, NULL);
	_tmp1 = NULL;
	_tmp0 = NULL;
	self->data = (_tmp1 = (_tmp0 = data, (_tmp0 == NULL) ? NULL : g_strdup (_tmp0)), self->data = (g_free (self->data), NULL), _tmp1);
	return self;
}


VbfStringLiteral* vbf_string_literal_new (const char* data) {
	return vbf_string_literal_construct (VBF_TYPE_STRING_LITERAL, data);
}


static char* vbf_string_literal_real_to_string (VbfConfigNode* base) {
	VbfStringLiteral * self;
	self = (VbfStringLiteral*) base;
	if (self->data == NULL) {
		return g_strdup ("(null)");
	} else {
		if (_vala_strcmp0 (self->data, "") == 0) {
			return g_strdup ("(empty)");
		} else {
			const char* _tmp2;
			_tmp2 = NULL;
			return (_tmp2 = self->data, (_tmp2 == NULL) ? NULL : g_strdup (_tmp2));
		}
	}
}


static void vbf_string_literal_class_init (VbfStringLiteralClass * klass) {
	vbf_string_literal_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = vbf_string_literal_finalize;
	VBF_CONFIG_NODE_CLASS (klass)->to_string = vbf_string_literal_real_to_string;
}


static void vbf_string_literal_instance_init (VbfStringLiteral * self) {
}


static void vbf_string_literal_finalize (GObject* obj) {
	VbfStringLiteral * self;
	self = VBF_STRING_LITERAL (obj);
	self->data = (g_free (self->data), NULL);
	G_OBJECT_CLASS (vbf_string_literal_parent_class)->finalize (obj);
}


GType vbf_string_literal_get_type (void) {
	static GType vbf_string_literal_type_id = 0;
	if (vbf_string_literal_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (VbfStringLiteralClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vbf_string_literal_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VbfStringLiteral), 0, (GInstanceInitFunc) vbf_string_literal_instance_init, NULL };
		vbf_string_literal_type_id = g_type_register_static (VBF_TYPE_CONFIG_NODE, "VbfStringLiteral", &g_define_type_info, 0);
	}
	return vbf_string_literal_type_id;
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




