/*
 *  vbfunresolvedconfignode.vala - Vala Build Framework library
 *  
 *  Copyright (C) 2008 - Andrea Del Signore <sejerpz@tin.it>
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 */

#include <vbfunresolvedconfignode.h>




enum  {
	VBF_UNRESOLVED_CONFIG_NODE_DUMMY_PROPERTY
};
static char* vbf_unresolved_config_node_real_to_string (VbfConfigNode* base);
static gpointer vbf_unresolved_config_node_parent_class = NULL;
static void vbf_unresolved_config_node_finalize (GObject* obj);



VbfUnresolvedConfigNode* vbf_unresolved_config_node_construct (GType object_type, const char* name) {
	VbfUnresolvedConfigNode * self;
	char* _tmp1;
	const char* _tmp0;
	g_return_val_if_fail (name != NULL, NULL);
	self = g_object_newv (object_type, 0, NULL);
	_tmp1 = NULL;
	_tmp0 = NULL;
	self->name = (_tmp1 = (_tmp0 = name, (_tmp0 == NULL) ? NULL : g_strdup (_tmp0)), self->name = (g_free (self->name), NULL), _tmp1);
	return self;
}


VbfUnresolvedConfigNode* vbf_unresolved_config_node_new (const char* name) {
	return vbf_unresolved_config_node_construct (VBF_TYPE_UNRESOLVED_CONFIG_NODE, name);
}


static char* vbf_unresolved_config_node_real_to_string (VbfConfigNode* base) {
	VbfUnresolvedConfigNode * self;
	const char* _tmp0;
	self = (VbfUnresolvedConfigNode*) base;
	_tmp0 = NULL;
	return (_tmp0 = self->name, (_tmp0 == NULL) ? NULL : g_strdup (_tmp0));
}


static void vbf_unresolved_config_node_class_init (VbfUnresolvedConfigNodeClass * klass) {
	vbf_unresolved_config_node_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = vbf_unresolved_config_node_finalize;
	VBF_CONFIG_NODE_CLASS (klass)->to_string = vbf_unresolved_config_node_real_to_string;
}


static void vbf_unresolved_config_node_instance_init (VbfUnresolvedConfigNode * self) {
}


static void vbf_unresolved_config_node_finalize (GObject* obj) {
	VbfUnresolvedConfigNode * self;
	self = VBF_UNRESOLVED_CONFIG_NODE (obj);
	self->name = (g_free (self->name), NULL);
	G_OBJECT_CLASS (vbf_unresolved_config_node_parent_class)->finalize (obj);
}


GType vbf_unresolved_config_node_get_type (void) {
	static GType vbf_unresolved_config_node_type_id = 0;
	if (vbf_unresolved_config_node_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (VbfUnresolvedConfigNodeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vbf_unresolved_config_node_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VbfUnresolvedConfigNode), 0, (GInstanceInitFunc) vbf_unresolved_config_node_instance_init, NULL };
		vbf_unresolved_config_node_type_id = g_type_register_static (VBF_TYPE_CONFIG_NODE, "VbfUnresolvedConfigNode", &g_define_type_info, 0);
	}
	return vbf_unresolved_config_node_type_id;
}




