/*
 *  vbfunresolvedconfignode.vala - Vala Build Framework library
 *  
 *  Copyright (C) 2008 - Andrea Del Signore <sejerpz@tin.it>
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 */

#ifndef __VBFUNRESOLVEDCONFIGNODE_H__
#define __VBFUNRESOLVEDCONFIGNODE_H__

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <vbfconfignode.h>

G_BEGIN_DECLS


#define VBF_TYPE_UNRESOLVED_CONFIG_NODE (vbf_unresolved_config_node_get_type ())
#define VBF_UNRESOLVED_CONFIG_NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VBF_TYPE_UNRESOLVED_CONFIG_NODE, VbfUnresolvedConfigNode))
#define VBF_UNRESOLVED_CONFIG_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VBF_TYPE_UNRESOLVED_CONFIG_NODE, VbfUnresolvedConfigNodeClass))
#define VBF_IS_UNRESOLVED_CONFIG_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VBF_TYPE_UNRESOLVED_CONFIG_NODE))
#define VBF_IS_UNRESOLVED_CONFIG_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VBF_TYPE_UNRESOLVED_CONFIG_NODE))
#define VBF_UNRESOLVED_CONFIG_NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VBF_TYPE_UNRESOLVED_CONFIG_NODE, VbfUnresolvedConfigNodeClass))

typedef struct _VbfUnresolvedConfigNode VbfUnresolvedConfigNode;
typedef struct _VbfUnresolvedConfigNodeClass VbfUnresolvedConfigNodeClass;
typedef struct _VbfUnresolvedConfigNodePrivate VbfUnresolvedConfigNodePrivate;

struct _VbfUnresolvedConfigNode {
	VbfConfigNode parent_instance;
	VbfUnresolvedConfigNodePrivate * priv;
	char* name;
};

struct _VbfUnresolvedConfigNodeClass {
	VbfConfigNodeClass parent_class;
};


VbfUnresolvedConfigNode* vbf_unresolved_config_node_construct (GType object_type, const char* name);
VbfUnresolvedConfigNode* vbf_unresolved_config_node_new (const char* name);
GType vbf_unresolved_config_node_get_type (void);


G_END_DECLS

#endif
