/*
 *  vtgbuildlogview.vala - Vala developer toys for GEdit
 *  
 *  Copyright (C) 2008 - Andrea Del Signore <sejerpz@tin.it>
 *  
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *   
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330,
 *  Boston, MA 02111-1307, USA.
 */

#ifndef __VTGBUILDLOGVIEW_H__
#define __VTGBUILDLOGVIEW_H__

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include "vtgplugininstance.h"
#include "vtgprojectmanager.h"
#include "vtgoutputview.h"

G_BEGIN_DECLS


#define VTG_TYPE_BUILD_LOG_VIEW (vtg_build_log_view_get_type ())
#define VTG_BUILD_LOG_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VTG_TYPE_BUILD_LOG_VIEW, VtgBuildLogView))
#define VTG_BUILD_LOG_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VTG_TYPE_BUILD_LOG_VIEW, VtgBuildLogViewClass))
#define VTG_IS_BUILD_LOG_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VTG_TYPE_BUILD_LOG_VIEW))
#define VTG_IS_BUILD_LOG_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VTG_TYPE_BUILD_LOG_VIEW))
#define VTG_BUILD_LOG_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VTG_TYPE_BUILD_LOG_VIEW, VtgBuildLogViewClass))

typedef struct _VtgBuildLogView VtgBuildLogView;
typedef struct _VtgBuildLogViewClass VtgBuildLogViewClass;
typedef struct _VtgBuildLogViewPrivate VtgBuildLogViewPrivate;

struct _VtgBuildLogView {
	GObject parent_instance;
	VtgBuildLogViewPrivate * priv;
};

struct _VtgBuildLogViewClass {
	GObjectClass parent_class;
};


VtgBuildLogView* vtg_build_log_view_construct (GType object_type, VtgPluginInstance* plugin_instance);
VtgBuildLogView* vtg_build_log_view_new (VtgPluginInstance* plugin_instance);
void vtg_build_log_view_initialize (VtgBuildLogView* self, VtgProjectManager* project);
void vtg_build_log_view_activate (VtgBuildLogView* self);
gboolean vtg_build_log_view_on_message_added (VtgBuildLogView* self, VtgOutputView* sender, const char* message);
void vtg_build_log_view_on_build_view_row_activated (VtgBuildLogView* self, GtkWidget* sender, const GtkTreePath* path, GtkTreeViewColumn* column);
void vtg_build_log_view_next_error (VtgBuildLogView* self);
void vtg_build_log_view_previous_error (VtgBuildLogView* self);
VtgPluginInstance* vtg_build_log_view_get_plugin_instance (VtgBuildLogView* self);
gint vtg_build_log_view_get_error_count (VtgBuildLogView* self);
gint vtg_build_log_view_get_warning_count (VtgBuildLogView* self);
GType vtg_build_log_view_get_type (void);
GType vtg_build_log_view_register_type (GTypeModule * module);


G_END_DECLS

#endif
