/*
 *  vtgplugin.vala - Vala developer toys for GEdit
 *  
 *  Copyright (C) 2008 - Andrea Del Signore <sejerpz@tin.it>
 *  
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *   
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330,
 *  Boston, MA 02111-1307, USA.
 */

#ifndef __VTGPLUGIN_H__
#define __VTGPLUGIN_H__

#include <glib.h>
#include <glib-object.h>
#include <gedit/gedit-plugin.h>
#include <gedit/gedit-window.h>
#include <gtk/gtk.h>
#include <gedit/gedit-document.h>
#include <gee/list.h>
#include "vtgbracketcompletion.h"
#include "vtgprojectdescriptor.h"
#include "vtgconfiguration.h"
#include "vtgprojectmanager.h"

G_BEGIN_DECLS


#define VTG_TYPE_PLUGIN (vtg_plugin_get_type ())
#define VTG_PLUGIN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VTG_TYPE_PLUGIN, VtgPlugin))
#define VTG_PLUGIN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VTG_TYPE_PLUGIN, VtgPluginClass))
#define VTG_IS_PLUGIN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VTG_TYPE_PLUGIN))
#define VTG_IS_PLUGIN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VTG_TYPE_PLUGIN))
#define VTG_PLUGIN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VTG_TYPE_PLUGIN, VtgPluginClass))

typedef struct _VtgPluginPrivate VtgPluginPrivate;

struct _VtgPlugin {
	GeditPlugin parent_instance;
	VtgPluginPrivate * priv;
};

struct _VtgPluginClass {
	GeditPluginClass parent_class;
};


VtgProjectDescriptor* vtg_plugin_project_descriptor_find_from_document (VtgPlugin* self, GeditDocument* document);
void vtg_plugin_on_project_closed (VtgPlugin* self, VtgProjectManagerUi* sender, VtgProjectManager* project);
gboolean vtg_plugin_project_need_save (VtgPlugin* self, VtgProjectManager* project);
void vtg_plugin_project_save_all (VtgPlugin* self, VtgProjectManager* project);
void vtg_plugin_on_project_loaded (VtgPlugin* self, VtgProjectManagerUi* sender, VtgProjectManager* project_manager);
VtgPlugin* vtg_plugin_construct (GType object_type);
VtgPlugin* vtg_plugin_new (void);
GeeList* vtg_plugin_get_projects (VtgPlugin* self);
VtgConfiguration* vtg_plugin_get_config (VtgPlugin* self);
GType vtg_plugin_get_type (void);
GType vtg_plugin_register_type (GTypeModule * module);
GType register_gedit_plugin (GTypeModule* module);


G_END_DECLS

#endif
