/*
 *  vtgprocesswatchinfo.vala - Vala developer toys for GEdit
 *  
 *  Copyright (C) 2008 - Andrea Del Signore <sejerpz@tin.it>
 *  
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *   
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330,
 *  Boston, MA 02111-1307, USA.
 */

#ifndef __VTGPROCESSWATCHINFO_H__
#define __VTGPROCESSWATCHINFO_H__

#include <glib.h>
#include <glib-object.h>

G_BEGIN_DECLS


#define VTG_TYPE_PROCESS_WATCH_INFO (vtg_process_watch_info_get_type ())
#define VTG_PROCESS_WATCH_INFO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VTG_TYPE_PROCESS_WATCH_INFO, VtgProcessWatchInfo))
#define VTG_PROCESS_WATCH_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VTG_TYPE_PROCESS_WATCH_INFO, VtgProcessWatchInfoClass))
#define VTG_IS_PROCESS_WATCH_INFO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VTG_TYPE_PROCESS_WATCH_INFO))
#define VTG_IS_PROCESS_WATCH_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VTG_TYPE_PROCESS_WATCH_INFO))
#define VTG_PROCESS_WATCH_INFO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VTG_TYPE_PROCESS_WATCH_INFO, VtgProcessWatchInfoClass))

typedef struct _VtgProcessWatchInfo VtgProcessWatchInfo;
typedef struct _VtgProcessWatchInfoClass VtgProcessWatchInfoClass;
typedef struct _VtgProcessWatchInfoPrivate VtgProcessWatchInfoPrivate;
typedef struct _VtgParamSpecProcessWatchInfo VtgParamSpecProcessWatchInfo;

struct _VtgProcessWatchInfo {
	GTypeInstance parent_instance;
	volatile int ref_count;
	VtgProcessWatchInfoPrivate * priv;
	guint id;
	GIOChannel* stdin;
	GIOChannel* stdout;
	GIOChannel* stderr;
	guint stdout_watch_id;
	guint stderr_watch_id;
};

struct _VtgProcessWatchInfoClass {
	GTypeClass parent_class;
	void (*finalize) (VtgProcessWatchInfo *self);
};

struct _VtgParamSpecProcessWatchInfo {
	GParamSpec parent_instance;
};


VtgProcessWatchInfo* vtg_process_watch_info_construct (GType object_type, guint id);
VtgProcessWatchInfo* vtg_process_watch_info_new (guint id);
void vtg_process_watch_info_cleanup (VtgProcessWatchInfo* self);
GParamSpec* vtg_param_spec_process_watch_info (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
gpointer vtg_value_get_process_watch_info (const GValue* value);
void vtg_value_set_process_watch_info (GValue* value, gpointer v_object);
GType vtg_process_watch_info_get_type (void);
GType vtg_process_watch_info_register_type (GTypeModule * module);
gpointer vtg_process_watch_info_ref (gpointer instance);
void vtg_process_watch_info_unref (gpointer instance);


G_END_DECLS

#endif
