/*
 *  vtgprojectexecuter.vala - Vala developer toys for GEdit
 *  
 *  Copyright (C) 2008 - Andrea Del Signore <sejerpz@tin.it>
 *  
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *   
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330,
 *  Boston, MA 02111-1307, USA.
 */

#ifndef __VTGPROJECTEXECUTER_H__
#define __VTGPROJECTEXECUTER_H__

#include <glib.h>
#include <glib-object.h>
#include <vbfproject.h>
#include <stdlib.h>
#include <string.h>
#include "vtgplugininstance.h"

G_BEGIN_DECLS


#define VTG_TYPE_PROJECT_EXECUTER (vtg_project_executer_get_type ())
#define VTG_PROJECT_EXECUTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VTG_TYPE_PROJECT_EXECUTER, VtgProjectExecuter))
#define VTG_PROJECT_EXECUTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VTG_TYPE_PROJECT_EXECUTER, VtgProjectExecuterClass))
#define VTG_IS_PROJECT_EXECUTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VTG_TYPE_PROJECT_EXECUTER))
#define VTG_IS_PROJECT_EXECUTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VTG_TYPE_PROJECT_EXECUTER))
#define VTG_PROJECT_EXECUTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VTG_TYPE_PROJECT_EXECUTER, VtgProjectExecuterClass))

typedef struct _VtgProjectExecuter VtgProjectExecuter;
typedef struct _VtgProjectExecuterClass VtgProjectExecuterClass;
typedef struct _VtgProjectExecuterPrivate VtgProjectExecuterPrivate;

struct _VtgProjectExecuter {
	GObject parent_instance;
	VtgProjectExecuterPrivate * priv;
};

struct _VtgProjectExecuterClass {
	GObjectClass parent_class;
};


VtgProjectExecuter* vtg_project_executer_construct (GType object_type, VtgPluginInstance* plugin_instance);
VtgProjectExecuter* vtg_project_executer_new (VtgPluginInstance* plugin_instance);
gboolean vtg_project_executer_execute (VtgProjectExecuter* self, VbfProject* project, const char* command_line);
void vtg_project_executer_kill_last (VtgProjectExecuter* self);
VtgPluginInstance* vtg_project_executer_get_plugin_instance (VtgProjectExecuter* self);
gboolean vtg_project_executer_get_is_executing (VtgProjectExecuter* self);
GType vtg_project_executer_get_type (void);
GType vtg_project_executer_register_type (GTypeModule * module);


G_END_DECLS

#endif
