/*
 *  vtgprojectexecuterdialog.vala - Vala developer toys for GEdit
 *  
 *  Copyright (C) 2008 - Andrea Del Signore <sejerpz@tin.it>
 *  
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *   
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330,
 *  Boston, MA 02111-1307, USA.
 */

#ifndef __VTGPROJECTEXECUTERDIALOG_H__
#define __VTGPROJECTEXECUTERDIALOG_H__

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include "vtgprojectmanager.h"

G_BEGIN_DECLS


#define VTG_TYPE_PROJECT_EXECUTER_DIALOG (vtg_project_executer_dialog_get_type ())
#define VTG_PROJECT_EXECUTER_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VTG_TYPE_PROJECT_EXECUTER_DIALOG, VtgProjectExecuterDialog))
#define VTG_PROJECT_EXECUTER_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VTG_TYPE_PROJECT_EXECUTER_DIALOG, VtgProjectExecuterDialogClass))
#define VTG_IS_PROJECT_EXECUTER_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VTG_TYPE_PROJECT_EXECUTER_DIALOG))
#define VTG_IS_PROJECT_EXECUTER_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VTG_TYPE_PROJECT_EXECUTER_DIALOG))
#define VTG_PROJECT_EXECUTER_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VTG_TYPE_PROJECT_EXECUTER_DIALOG, VtgProjectExecuterDialogClass))

typedef struct _VtgProjectExecuterDialog VtgProjectExecuterDialog;
typedef struct _VtgProjectExecuterDialogClass VtgProjectExecuterDialogClass;
typedef struct _VtgProjectExecuterDialogPrivate VtgProjectExecuterDialogPrivate;
typedef struct _VtgParamSpecProjectExecuterDialog VtgParamSpecProjectExecuterDialog;

struct _VtgProjectExecuterDialog {
	GTypeInstance parent_instance;
	volatile int ref_count;
	VtgProjectExecuterDialogPrivate * priv;
};

struct _VtgProjectExecuterDialogClass {
	GTypeClass parent_class;
	void (*finalize) (VtgProjectExecuterDialog *self);
};

struct _VtgParamSpecProjectExecuterDialog {
	GParamSpec parent_instance;
};


VtgProjectExecuterDialog* vtg_project_executer_dialog_construct (GType object_type, GtkWindow* parent, VtgProjectManager* project);
VtgProjectExecuterDialog* vtg_project_executer_dialog_new (GtkWindow* parent, VtgProjectManager* project);
gint vtg_project_executer_dialog_run (VtgProjectExecuterDialog* self);
const char* vtg_project_executer_dialog_get_command_line (VtgProjectExecuterDialog* self);
GParamSpec* vtg_param_spec_project_executer_dialog (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
gpointer vtg_value_get_project_executer_dialog (const GValue* value);
void vtg_value_set_project_executer_dialog (GValue* value, gpointer v_object);
GType vtg_project_executer_dialog_get_type (void);
GType vtg_project_executer_dialog_register_type (GTypeModule * module);
gpointer vtg_project_executer_dialog_ref (gpointer instance);
void vtg_project_executer_dialog_unref (gpointer instance);


G_END_DECLS

#endif
