/*
 *  vtgprojectmanagerui.vala - Vala developer toys for GEdit
 *  
 *  Copyright (C) 2008 - Andrea Del Signore <sejerpz@tin.it>
 *  
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *   
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330,
 *  Boston, MA 02111-1307, USA.
 */

#ifndef __VTGPROJECTMANAGERUI_H__
#define __VTGPROJECTMANAGERUI_H__

#include <glib.h>
#include <glib-object.h>
#include "vtgbracketcompletion.h"
#include "vtgprojectmanager.h"

G_BEGIN_DECLS


#define VTG_TYPE_PROJECT_MANAGER_UI (vtg_project_manager_ui_get_type ())
#define VTG_PROJECT_MANAGER_UI(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VTG_TYPE_PROJECT_MANAGER_UI, VtgProjectManagerUi))
#define VTG_PROJECT_MANAGER_UI_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VTG_TYPE_PROJECT_MANAGER_UI, VtgProjectManagerUiClass))
#define VTG_IS_PROJECT_MANAGER_UI(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VTG_TYPE_PROJECT_MANAGER_UI))
#define VTG_IS_PROJECT_MANAGER_UI_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VTG_TYPE_PROJECT_MANAGER_UI))
#define VTG_PROJECT_MANAGER_UI_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VTG_TYPE_PROJECT_MANAGER_UI, VtgProjectManagerUiClass))

typedef struct _VtgProjectManagerUiPrivate VtgProjectManagerUiPrivate;

struct _VtgProjectManagerUi {
	GObject parent_instance;
	VtgProjectManagerUiPrivate * priv;
};

struct _VtgProjectManagerUiClass {
	GObjectClass parent_class;
};


VtgProjectManagerUi* vtg_project_manager_ui_construct (GType object_type, VtgPluginInstance* plugin_instance);
VtgProjectManagerUi* vtg_project_manager_ui_new (VtgPluginInstance* plugin_instance);
void vtg_project_manager_ui_deactivate (VtgProjectManagerUi* self);
void vtg_project_manager_ui_close_project (VtgProjectManagerUi* self, VtgProjectManager* project);
VtgPluginInstance* vtg_project_manager_ui_get_plugin_instance (VtgProjectManagerUi* self);
VtgProjectView* vtg_project_manager_ui_get_project_view (VtgProjectManagerUi* self);
GType vtg_project_manager_ui_get_type (void);
GType vtg_project_manager_ui_register_type (GTypeModule * module);


G_END_DECLS

#endif
