/*
 *  vtgprojectmanagerview.vala - Vala developer toys for GEdit
 *  
 *  Copyright (C) 2008 - Andrea Del Signore <sejerpz@tin.it>
 *  
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *   
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330,
 *  Boston, MA 02111-1307, USA.
 */

#ifndef __VTGPROJECTVIEW_H__
#define __VTGPROJECTVIEW_H__

#include <glib.h>
#include <glib-object.h>
#include <vbfproject.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include "vtgbracketcompletion.h"
#include "vtgprojectmanager.h"

G_BEGIN_DECLS


#define VTG_TYPE_PROJECT_VIEW (vtg_project_view_get_type ())
#define VTG_PROJECT_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VTG_TYPE_PROJECT_VIEW, VtgProjectView))
#define VTG_PROJECT_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VTG_TYPE_PROJECT_VIEW, VtgProjectViewClass))
#define VTG_IS_PROJECT_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VTG_TYPE_PROJECT_VIEW))
#define VTG_IS_PROJECT_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VTG_TYPE_PROJECT_VIEW))
#define VTG_PROJECT_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VTG_TYPE_PROJECT_VIEW, VtgProjectViewClass))

typedef struct _VtgProjectViewPrivate VtgProjectViewPrivate;

struct _VtgProjectView {
	GObject parent_instance;
	VtgProjectViewPrivate * priv;
};

struct _VtgProjectViewClass {
	GObjectClass parent_class;
};


VtgProjectView* vtg_project_view_construct (GType object_type, VtgPluginInstance* plugin_instance);
VtgProjectView* vtg_project_view_new (VtgPluginInstance* plugin_instance);
void vtg_project_view_add_project (VtgProjectView* self, VbfProject* project);
void vtg_project_view_remove_project (VtgProjectView* self, VbfProject* project);
void vtg_project_view_on_project_view_row_activated (VtgProjectView* self, GtkWidget* sender, const GtkTreePath* path, GtkTreeViewColumn* column);
gboolean vtg_project_view_on_project_view_button_press (VtgProjectView* self, GtkWidget* sender, const GdkEventButton* event);
void vtg_project_view_on_project_combobox_changed (VtgProjectView* self, GtkWidget* sender);
VtgProjectManager* vtg_project_view_get_current_project (VtgProjectView* self);
void vtg_project_view_set_current_project (VtgProjectView* self, VtgProjectManager* value);
GType vtg_project_view_get_type (void);
GType vtg_project_view_register_type (GTypeModule * module);


G_END_DECLS

#endif
